displayIcon=Turbine.UI.Window()
displayIcon:SetSize(32,32)
displayIcon:SetPosition(0,0)
displayIcon:SetZOrder(1)
displayIcon:SetVisible(true)
displayIcon.MouseClick=function()
	displayWindow:SetVisible(not displayWindow:IsVisible())
	if displayWindow:IsVisible() then
		refreshDisplay()
	end
end
displayIcon.MoveX=-1;
displayIcon.MoveY=0;
displayIcon.Moving=false;

displayIcon.MouseDown=function(sender,args)
	if displayIcon:IsControlKeyDown() then
--		displayIcon:SetBackground(displayIcon.HoverImage);
		displayIcon.MoveX=args.X;
		displayIcon.MoveY=args.Y;
	end
end
displayIcon.MouseUp=function(sender,args)
--	displayIcon:SetBackground(displayIcon.UpImage);
	displayIcon.MoveX=-1;
	displayIcon.MoveY=0;
end
displayIcon.MouseMove=function(sender,args)
	if displayIcon.MoveX~=-1 and (args.X~=displayIcon.MoveX or args.Y~= displayIcon.MoveY) then
--		displayIcon:SetBackground(displayIcon.MoveImage);
		displayIcon.Moving=true;
		local newLeft=displayIcon:GetLeft()-(displayIcon.MoveX-args.X)
		local newTop=displayIcon:GetTop()-(displayIcon.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-displayIcon:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-displayIcon:GetWidth() end;
		if newTop<0 then newTop=0 end;
		if newTop>(Turbine.UI.Display.GetHeight()-displayIcon:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-displayIcon:GetHeight() end;
		displayIcon:SetPosition(newLeft,newTop);
		if setupWindow~=nil and setupWindow:IsVisible() then
			setupWindow.iconLeft:SetText(newLeft);
			setupWindow.iconTop:SetText(newTop);
		end
	end
end


--0x4101e188 (24x24)
--0X4110DDB4 (25X25)
displayWindow=Turbine.UI.Lotro.Window()
displayWindow:SetSize(480,400)
displayWindow:SetMinimumWidth(480)
displayWindow:SetMinimumHeight(140)
displayWindow:SetResizable(true)

displayWindow:SetText("Wallet")
displayWindow.Compact=Turbine.UI.Lotro.CheckBox()
displayWindow.Compact:SetParent(displayWindow)
displayWindow.Compact:SetSize(100,20)
displayWindow.Compact:SetText(" Compact")
displayWindow.Compact:SetPosition(35,30)
displayWindow.Compact:SetChecked(true)
displayWindow.Compact.CheckedChanged=function(sender,args)
	refreshDisplay()
end
displayWindow.SortCaption=Turbine.UI.Label()
displayWindow.SortCaption:SetParent(displayWindow)
displayWindow.SortCaption:SetSize(50,20)
displayWindow.SortCaption:SetPosition(140,30)
displayWindow.SortCaption:SetText("Sort:")
displayWindow.SortCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
displayWindow.SortOpt=RadioButtonGroup()
displayWindow.SortOpt:SetParent(displayWindow)
displayWindow.SortOpt.UnselectedIcon="GaranStuff/Wallet/Resources/RB_unselected.tga";
displayWindow.SortOpt.SelectedIcon="GaranStuff/Wallet/Resources/RB_selected.tga";
displayWindow.SortOpt:SetPosition(displayWindow.SortCaption:GetLeft()+displayWindow.SortCaption:GetWidth(),displayWindow.SortCaption:GetTop())
displayWindow.SortOpt:SetSize(displayWindow:GetWidth()-35-displayWindow.SortOpt:GetLeft(),20)
displayWindow.SortOpt:SetFont(Turbine.UI.Lotro.Font.Verdana12)
displayWindow.SortOpt.IconWidth=16;
displayWindow.SortOpt.IconHeight=16;
displayWindow.SortOpt:SetBorderColor(Turbine.UI.Color.Black);
displayWindow.SortOpt:SetBackColor(Turbine.UI.Color.Black);
displayWindow.SortOpt:SetTextColor(Turbine.UI.Color.White);
displayWindow.SortOpt:AddChoice("Float Order",1);
displayWindow.SortOpt:AddChoice("Currency",2);
displayWindow.SortOpt:AddChoice("Character",3);
displayWindow.SortOpt:SetRows(1);
displayWindow.SortOpt:SetSelectedChoice(1);
displayWindow.SortOpt.SelectionChanged=function()
	refreshDisplay()
end
displayWindow.FilterCaption=Turbine.UI.Label()
displayWindow.FilterCaption:SetParent(displayWindow)
displayWindow.FilterCaption:SetSize(100,20)
displayWindow.FilterCaption:SetPosition(35,55)
displayWindow.FilterCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
displayWindow.FilterCaption:SetText("Filter:")
displayWindow.FilterText=Turbine.UI.Lotro.TextBox()
displayWindow.FilterText:SetParent(displayWindow)
displayWindow.FilterText:SetFont(Turbine.UI.Lotro.Font.Verdana16)
displayWindow.FilterText:SetMultiline(false)
displayWindow.FilterText:SetPosition(displayWindow.FilterCaption:GetLeft()+displayWindow.FilterCaption:GetWidth(),displayWindow.FilterCaption:GetTop())
displayWindow.FilterText:SetSize(displayWindow:GetWidth()-35-displayWindow.FilterText:GetLeft(),20)
filterText=""
displayWindow.FilterText.TextChanged=function()
	newText=displayWindow.FilterText:GetText()
	if newText~=filterText then
		filterText=newText
		filterDisplay()
	end
end

displayWindow.CurrencyList=Turbine.UI.ListBox()
displayWindow.CurrencyList:SetBackColor(Turbine.UI.Color.DarkBlue)
displayWindow.CurrencyList:SetParent(displayWindow)
displayWindow.CurrencyList:SetPosition(5,80)
displayWindow.CurrencyList:SetSize(displayWindow:GetWidth()-20,displayWindow:GetHeight()-100)
displayWindow.CurrencyList:SetBackColor(Turbine.UI.Color(.05,.05,.1))
displayWindow.CurrencyVScroll=Turbine.UI.Lotro.ScrollBar()
displayWindow.CurrencyVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
displayWindow.CurrencyVScroll:SetParent(displayWindow);
displayWindow.CurrencyVScroll:SetSize(10,displayWindow.CurrencyList:GetHeight());
displayWindow.CurrencyVScroll:SetPosition(displayWindow:GetWidth()-15,displayWindow.CurrencyList:GetTop());
displayWindow.CurrencyList:SetVerticalScrollBar(displayWindow.CurrencyVScroll);

displayWindow.SizeChanged=function(sender,args)
	displayWindow.CurrencyList:SetSize(displayWindow:GetWidth()-20,displayWindow:GetHeight()-100)
	displayWindow.CurrencyVScroll:SetHeight(displayWindow.CurrencyList:GetHeight());
	displayWindow.CurrencyVScroll:SetLeft(displayWindow:GetWidth()-15);
	local rowWidth=displayWindow.CurrencyList:GetWidth()
	local tmpIndex
	for tmpIndex=1,displayWindow.CurrencyList:GetItemCount() do
		local tmpRow=displayWindow.CurrencyList:GetItem(tmpIndex)
		tmpRow:SetWidth(rowWidth)
		if tmpRow.IsGold then
			tmpRow.Name:SetWidth(rowWidth-tmpRow.Qty:GetWidth()-tmpRow.Qty2:GetWidth()-tmpRow.Qty3:GetWidth()-95-tmpRow.Name:GetLeft())
			tmpRow.Qty:SetLeft(tmpRow.Name:GetLeft()+tmpRow.Name:GetWidth())
			tmpRow.Icon:SetLeft(tmpRow.Qty:GetLeft()+tmpRow.Qty:GetWidth())
			tmpRow.Qty2:SetLeft(tmpRow.Icon:GetLeft()+32)
			tmpRow.Icon2:SetLeft(tmpRow.Qty2:GetLeft()+tmpRow.Qty2:GetWidth())
			tmpRow.Qty3:SetLeft(tmpRow.Icon2:GetLeft()+32)
			tmpRow.Icon3:SetLeft(tmpRow.Qty3:GetLeft()+tmpRow.Qty3:GetWidth())
		else
			tmpRow.Name:SetWidth(rowWidth-220)
			tmpRow.Qty:SetLeft(tmpRow.Name:GetWidth())
			if tmpRow.Tot~=nil then
				tmpRow.Tot:SetLeft(tmpRow.Qty:GetLeft()+tmpRow.Qty:GetWidth()+5)
			end
			tmpRow.Icon:SetLeft(rowWidth-20)
		end
	end
end

filterDisplay=function()
	newText=displayWindow.FilterText:GetText()
	newText=string.lower(string.stripaccent(newText))
	-- apply filter
	local tmpIndex
	local even=true
	for tmpIndex=1,displayWindow.CurrencyList:GetItemCount() do
		local tmpRow=displayWindow.CurrencyList:GetItem(tmpIndex)
		if tmpRow.Header~=nil then
			tmpRow:SetHeight(tmpRow.VisibleHeight)
			even=false
		elseif newText=="" or string.find(string.lower(string.stripaccent(tmpRow.CurrencyName)),newText)~=nil then
			tmpRow:SetHeight(tmpRow.VisibleHeight)
			even=not even
			if even then
				tmpRow.Name:SetBackColor(Turbine.UI.Color(.05,.05,.15))
				tmpRow.Qty:SetBackColor(Turbine.UI.Color(.05,.05,.15))
				if tmpRow.Qty2~=nil then
					tmpRow.Qty2:SetBackColor(Turbine.UI.Color(.05,.05,.15))
					tmpRow.Qty3:SetBackColor(Turbine.UI.Color(.05,.05,.15))
				end
				if tmpRow.Tot~=nil then
					tmpRow.Tot:SetBackColor(Turbine.UI.Color(.05,.05,.15))
				end
			else
				tmpRow.Name:SetBackColor(nil)
				tmpRow.Qty:SetBackColor(nil)
				if tmpRow.Qty2~=nil then
					tmpRow.Qty2:SetBackColor(nil)
					tmpRow.Qty3:SetBackColor(nil)
				end
				if tmpRow.Tot~=nil then
					tmpRow.Tot:SetBackColor(nil)
				end
			end
		else
			tmpRow:SetHeight(0)
		end
	end
end
refreshDisplay=function()
	if walletWindow==nil then
		return; -- this routine gets called during setup before it can run
	end
	-- refresh the display with the current options
	-- load table with current values
	local tmpTable={}
	local sortOpt=displayWindow.SortOpt:GetValue()
	local compact=displayWindow.Compact:IsChecked()
	local tmpHead=""
	for k,v in ipairs(walletSettings) do
		if not v[5] then
			tmpHead=v[10]
			if tmpHead==nil then tmpHead="" end
		end
		-- {index,currencyID,order,name,char,qty,dock,groupheading,totQty}
		if k==dpWalletIndex or Currency[v[1]][7] then
			table.insert(tmpTable,{k,v[1],v[4],Currency[v[1]][1],"",walletWindow[k].Value:GetText(),v[5],tmpHead,nil})
		else
			local totQty=AccountQty[Currency[v[1]][1]].Total
			for name,qty in pairs(AccountQty[Currency[v[1]][1]]) do
				if name=="Total" and ((not compact  or sortOpt==3) or k==goldWalletIndex) then
					table.insert(tmpTable,{k,v[1],v[4],Currency[v[1]][1],"",qty,v[5],tmpHead,totQty})
				else
					if not compact or sortOpt==3 then
						table.insert(tmpTable,{k,v[1],v[4],Currency[v[1]][1],name,qty,v[5],tmpHead,totQty})
					else
						if name==charName then
							table.insert(tmpTable,{k,v[1],v[4],Currency[v[1]][1],name,qty,v[5],tmpHead,totQty})
						end
					end
				end
			end
		end
	end
	if sortOpt==1 then
		-- sort on [3] then [5]
		table.sort(tmpTable,function(arg1,arg2) if arg1[3]<arg2[3] then return true elseif arg1[3]==arg2[3] and arg1[5]<arg2[5] then return true end end)
	elseif sortOpt==2 then
		-- sort on [4] then [5]
		table.sort(tmpTable,function(arg1,arg2) if arg1[4]<arg2[4] then return true elseif arg1[4]==arg2[4] and arg1[5]<arg2[5] then return true end end)
	else
		-- sort on [5] then [3]
		table.sort(tmpTable,function(arg1,arg2) if arg1[5]<arg2[5] then return true elseif arg1[5]==arg2[5] and arg1[3]<arg2[3] then return true end end)
	end
	displayWindow.CurrencyList:ClearItems()
	-- sort table based on group and sort
		-- if group
	local even=true
	local tmpGroup=nil
	for k,v in ipairs(tmpTable) do
		if sortOpt==1 then
			if tmpGroup~=v[8] then
				tmpGroup=v[8]
				local tmpRow1=Turbine.UI.Control()
				tmpRow1:SetParent(displayWindow.CurrencyList)
				tmpRow1:SetSize(displayWindow.CurrencyList:GetWidth(),25)
				tmpRow1:SetBackColor(Turbine.UI.Color(0,0,.1))
				tmpRow1.Header=true
				tmpRow1.VisibleHeight=25
				tmpRow1.Name=Turbine.UI.Label()
				tmpRow1.Name:SetParent(tmpRow1)
				tmpRow1.Name:SetOutlineColor(Turbine.UI.Color(.1,.1,.1));
				tmpRow1.Name:SetFontStyle(Turbine.UI.FontStyle.Outline);
				tmpRow1.Name:SetForeColor(Turbine.UI.Color(.9,.85,.5))
				tmpRow1.Name:SetFont(Turbine.UI.Lotro.Font.Verdana20)
				tmpRow1.IsGold=false
				if tmpGroup=="" then
					tmpRow1.Name:SetText("------------------------------")
				else
					tmpRow1.Name:SetText(tmpGroup)
				end
				tmpRow1.Name:SetSize(tmpRow1:GetWidth(),20)
				tmpRow1.Qty=Turbine.UI.Control()
				tmpRow1.Icon=Turbine.UI.Control()
				displayWindow.CurrencyList:AddItem(tmpRow1)
			end
		end
		if sortOpt==3 then
			if tmpGroup~=v[5] then
				tmpGroup=v[5]
				local tmpRow1=Turbine.UI.Control()
				tmpRow1:SetParent(displayWindow.CurrencyList)
				tmpRow1:SetSize(displayWindow.CurrencyList:GetWidth(),25)
				tmpRow1:SetBackColor(Turbine.UI.Color(0,0,.1))
				tmpRow1.Header=true
				tmpRow1.VisibleHeight=25
				tmpRow1.Name=Turbine.UI.Label()
				tmpRow1.Name:SetParent(tmpRow1)
				tmpRow1.Name:SetOutlineColor(Turbine.UI.Color(.1,.1,.1));
				tmpRow1.Name:SetFontStyle(Turbine.UI.FontStyle.Outline);
				tmpRow1.Name:SetForeColor(Turbine.UI.Color(.9,.85,.5))
				tmpRow1.Name:SetFont(Turbine.UI.Lotro.Font.Verdana20)
				tmpRow1.IsGold=false
				if tmpGroup=="" then
					tmpRow1.Name:SetText("Account")
				else
					tmpRow1.Name:SetText(tmpGroup)
				end
				tmpRow1.Name:SetSize(tmpRow1:GetWidth(),20)
				tmpRow1.Qty=Turbine.UI.Control()
				tmpRow1.Icon=Turbine.UI.Control()
				displayWindow.CurrencyList:AddItem(tmpRow1)
			end
		end
		even=not even
		local tmpRow=Turbine.UI.Control()
		tmpRow:SetParent(displayWindow.CurrencyList)
		tmpRow:SetSize(displayWindow.CurrencyList:GetWidth(),21)
		tmpRow.VisibleHeight=21
		tmpRow.CurrencyName=v[4]
		tmpRow.Name=Turbine.UI.Label()
		tmpRow.Name:SetParent(tmpRow)
		tmpRow.IsGold=(v[1]==goldWalletIndex)
		if v[5]=="" or compact or sortOpt==3 then
			tmpRow.Name:SetSize(tmpRow:GetWidth()-220,20)
			if tmpRow.IsGold then
				if v[5]=="" then
					tmpRow.Name:SetText(v[4].." Total:")
				else
					tmpRow.Name:SetText(v[4].." "..v[5]..":")
				end
			else
				tmpRow.Name:SetText(v[4]..":")
			end
		else
			tmpRow.Name:SetLeft(25)
			tmpRow.Name:SetSize(tmpRow:GetWidth()-245,20)
			tmpRow.Name:SetText(tostring(v[5]))
		end
		tmpRow.Qty=Turbine.UI.Label()
		tmpRow.Qty:SetParent(tmpRow)
		tmpRow.Qty:SetLeft(tmpRow.Name:GetLeft()+tmpRow.Name:GetWidth())
		tmpRow.Qty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
		tmpRow.Icon=Turbine.UI.Control()
		tmpRow.Icon:SetParent(tmpRow)
		tmpRow.Icon:SetSize(16,16)
		tmpRow.Icon:SetPosition(tmpRow:GetWidth()-20,2)
		tmpRow.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		tmpRow.Icon:SetBackground(Currency[v[2]][3])
		if v[1]==goldWalletIndex then
			tmpRow.Qty:SetSize(walletWindow[goldWalletIndex].GPText:GetWidth(),20)
			tmpRow.Qty2=Turbine.UI.Label()
			tmpRow.Qty2:SetParent(tmpRow)
			tmpRow.Qty2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
			tmpRow.Qty2:SetSize(walletWindow[goldWalletIndex].SPText:GetWidth(),20)
			tmpRow.Qty3=Turbine.UI.Label()
			tmpRow.Qty3:SetParent(tmpRow)
			tmpRow.Qty3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
			tmpRow.Qty3:SetSize(walletWindow[goldWalletIndex].CPText:GetWidth(),20)
			tmpRow.Name:SetWidth(tmpRow:GetWidth()-tmpRow.Qty:GetWidth()-tmpRow.Qty2:GetWidth()-tmpRow.Qty3:GetWidth()-95-tmpRow.Name:GetLeft())
			tmpRow.Qty:SetLeft(tmpRow.Name:GetLeft()+tmpRow.Name:GetWidth())
			tmpRow.Icon:SetWidth(27)
			tmpRow.Icon:SetLeft(tmpRow.Qty:GetLeft()+tmpRow.Qty:GetWidth())
			tmpRow.Icon:SetBackground(0x41007e7b)
			tmpRow.Qty2:SetLeft(tmpRow.Icon:GetLeft()+32)
			tmpRow.Icon2=Turbine.UI.Control()
			tmpRow.Icon2:SetParent(tmpRow)
			tmpRow.Icon2:SetSize(27,16)
			tmpRow.Icon2:SetPosition(tmpRow.Qty2:GetLeft()+tmpRow.Qty2:GetWidth(),2)
			tmpRow.Icon2:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			tmpRow.Icon2:SetBackground(0x41007e7c)
			tmpRow.Qty3:SetLeft(tmpRow.Icon2:GetLeft()+32)
			tmpRow.Icon3=Turbine.UI.Control()
			tmpRow.Icon3:SetParent(tmpRow)
			tmpRow.Icon3:SetSize(27,16)
			tmpRow.Icon3:SetPosition(tmpRow.Qty3:GetLeft()+tmpRow.Qty3:GetWidth(),2)
			tmpRow.Icon3:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			tmpRow.Icon3:SetBackground(0x41007e7d)
			local tmpCP=v[6]
			local tmpGP=math.floor(tmpCP/100000)
			tmpCP=tmpCP-tmpGP*100000
			local tmpSP=math.floor(tmpCP/100)
			tmpCP=tmpCP-tmpSP*100
			tmpRow.Qty:SetText(tmpGP)
			tmpRow.Qty2:SetText(tmpSP)
			tmpRow.Qty3:SetText(tmpCP)
			tmpRow.Qty2:SetMouseVisible(false)
			tmpRow.Icon2:SetMouseVisible(false)
			tmpRow.Qty3:SetMouseVisible(false)
			tmpRow.Icon3:SetMouseVisible(false)

			tmpRow.MouseHover=function()
				hoverMenu:GetItems():Clear();
				local tmpName=Currency[walletSettings[v[1]][1]][1]
				local tmpCP=AccountQty[tmpName].Total
				local tmpGP=math.floor(tmpCP/100000)
				tmpCP=tmpCP-tmpGP*100000
				local tmpSP=math.floor(tmpCP/100)
				tmpCP=tmpCP-tmpSP*100
				hoverMenu:GetItems():Add(Turbine.UI.MenuItem("Total: "..tostring(tmpGP).."gp "..tostring(tmpSP).."sp "..tostring(tmpCP).."cp"));
				local disp={}
				for char,qty in pairs(AccountQty[tmpName]) do
					if char~="Total" then
						tmpCP=qty
						tmpGP=math.floor(tmpCP/100000)
						tmpCP=tmpCP-tmpGP*100000
						tmpSP=math.floor(tmpCP/100)
						tmpCP=tmpCP-tmpSP*100
						disp[#disp+1]=tostring(char).." "..tostring(tmpGP).."gp "..tostring(tmpSP).."sp "..tostring(tmpCP).."cp"
					end
				end
				table.sort(disp)
				for index,val in ipairs(disp) do
					hoverMenu:GetItems():Add(Turbine.UI.MenuItem(val));
				end
				hoverMenu:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20);
			end

		elseif v[1]==dpWalletIndex then
			tmpRow.Qty:SetSize(195,20)
			-- dp
			tmpRow.Qty:SetForeColor(accountColor);
			tmpRow.Qty:SetText(v[6])
		else
			if Currency[v[2]][7] then
				tmpRow.Qty:SetSize(195,20)
				tmpRow.Qty:SetForeColor(accountColor);
			else
				tmpRow.Qty:SetSize(95,20)
				tmpRow.Tot=Turbine.UI.Label()
				tmpRow.Tot:SetParent(tmpRow)
				tmpRow.Tot:SetSize(95,20)
				tmpRow.Tot:SetLeft(tmpRow.Qty:GetLeft()+100)
				tmpRow.Tot:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
				tmpRow.Tot:SetForeColor(Turbine.UI.Color.LightBlue)
				tmpRow.Tot:SetText(walletWindow[v[1]].TotValue:GetText())
				tmpRow.Tot:SetMouseVisible(false)

				tmpRow.MouseHover=function()
					hoverMenu:GetItems():Clear();
					local tmpName=Currency[walletSettings[v[1]][1]][1]
					hoverMenu:GetItems():Add(Turbine.UI.MenuItem("Total: "..AccountQty[tmpName].Total));
					local disp={}
					for char,qty in pairs(AccountQty[tmpName]) do
						if char~="Total" then
							disp[#disp+1]=tostring(char).." "..tostring(qty)
						end
					end
					table.sort(disp)
					for index,val in ipairs(disp) do
						hoverMenu:GetItems():Add(Turbine.UI.MenuItem(val));
					end
					hoverMenu:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20);
				end
			end
			tmpRow.Qty:SetText(v[6])
		end
		tmpRow.Name:SetMouseVisible(false)
		tmpRow.Qty:SetMouseVisible(false)
		tmpRow.Icon:SetMouseVisible(false)

		displayWindow.CurrencyList:AddItem(tmpRow)
	end
	filterDisplay()
end